#include<bits/stdc++.h>

using namespace std;
const long maxN=1e5+3;
vector<vector<long>> v(maxN);
long dp[maxN];

long brdeca(int vr) {
	if(dp[vr]!=0) return dp[vr];
	int br=0;
	for(auto t: v[vr]){
		br+=brdeca(t)+1;
	}
	return (dp[vr]=br);
}
int main() {
ios_base::sync_with_stdio(0);
cin.tie(NULL);
cout.tie(NULL);
long n; cin>>n;
for(long i=0;i<n;i++){
	long u,v; cin>>u>>v;
	u--, v--;
	v[u].push_back(v);
}
long q; cin>>q;
while(q--){
	long m; cin>>m;
	cout<<brdeca(m-1)<<'\n';
}


return 0;
}